(***********************************************************************
This file was generated automatically by the Mathematica front end.
It contains Initialization cells from a Notebook file, which typically
will have the same name as this file except ending in ".nb" instead of
".m".

This file is intended to be loaded into the Mathematica kernel using
the package loading commands Get or Needs.  Doing so is equivalent to
using the Evaluate Initialiation Cells menu command in the front end.

DO NOT EDIT THIS FILE.  This entire file is regenerated automatically 
each time the parent Notebook file is saved in the Mathematica front end.
Any changes you make to this file will be overwritten.
***********************************************************************)

Gabor::usage= "Gabor[x,frequency,scale,phase]: Gabor function. The first three arguments may be vectors.";

Gabor[x_,frequency_,scale_,phase_] :=
   Cos[2 Pi frequency x  + phase] Exp[- Pi (x/scale)^2]

Gabor[x_List,frequency_List,scale_List,phase_] :=
 Cos[2 Pi (frequency . x) + phase] Exp[- Pi (x^2) . (scale^-2)]

GaborImage::usage= "GaborImage[size,frequency,scale,phase]: Compute a 2D image of a Gabor function. The first three arguments are vectors of equal length, and a tensor is created with rank equal to the vector length. frequency is in units of cycles/image. Phase defaults to 0. Arguments may also take the form in which only frequency is a list, in which case size and scale are equal for all two dimensions.";

GaborImage[size_?(Length[#]>2&), frequency_List, 
  scale_List, phase_:0] :=
  GaborImageDirect[size,frequency,scale, phase]

GaborImage[size_List,frequency_List,scale_List,phase_:0] :=
 Module[ {cu,cv,su,sv,gu,gv,f,hw,ss,p},
 f = N[2. Pi frequency /size];
 hw = N[size/2.];
 ss = N[Pi/(scale^2.)];
 p = {phase,0};
 {gu,gv} = MapThread[
   Table[N[Exp[- x^2 #1]] ,{x,-#2,#2-1}]&
   ,{ss,hw}];
 {{cu,cv},{su,sv}} = Function[z,{gu,gv} MapThread[
   Table[N[z[#1 x + #3]] ,{x,-#2,#2-1}]&  
   ,{f,hw,p}]] /@ {Cos,Sin};
  Outer[Times, cv, cu] - Outer[Times, sv, su]
 ]

GaborImage[size_,frequency_List,scale_,phase_:0] :=
 GaborImage[size {1,1},frequency,scale {1,1},phase] 

GaborImageDirect[size_List,frequency_List,scale_List
  , phase_:0] :=
 Array[ N[
 Gabor[Reverse[{##}]-N[1+size/2]
      ,N[frequency/size], scale,phase]]& , Reverse[size] ]