(*******************************************************************
This file was generated automatically by the Mathematica front end.
It contains Initialization cells from a Notebook file, which
typically will have the same name as this file except ending in
".nb" instead of ".m".

This file is intended to be loaded into the Mathematica kernel using
the package loading commands Get or Needs.  Doing so is equivalent
to using the Evaluate Initialization Cells menu command in the front
end.

DO NOT EDIT THIS FILE.  This entire file is regenerated
automatically each time the parent Notebook file is saved in the
Mathematica front end.  Any changes you make to this file will be
overwritten.
***********************************************************************)













<< Filtering.m









MakeGaborArray::usage="MakeGaborArray[maxSize_,minSize_,octaves_:1., nor_:4, fMax_:1, aspectRatio_:1]: Create a two-dimensional array of Gabor Filters, varying in orientation and frequency. Each filter is a two-dimensional discrete fourier transform (DFT), suitable for convolution via multiplication in the DFT domain. The size of the largest filters is maxSize pixels. Its frequency is fMax/4 cycle/pixel. Filters decline in frequency from this value by factors of two. The filter bandwidth is octaves. The size of the smallest filter is minSize. The number of orientations is nor. The filters are analytic, meaning that when they multiply the DFT of an image, they produce a result whose real and imaginary parts are the responses of even and odd receptive fields, respectively. The function remembers previously computed arrays.";



MakeGaborArray[max_, min_:8, octaves_:1.
   , nor_:4, fmax_:1., aspectRatio_:1] :=
 MakeGaborArray[max, min, octaves, nor, fmax] =
 Module[{dor,nlayers,fsize},
  dor = N[Pi / nor];
  nlayers = 1+Floor[Log[2,max/min]];
  Table[(
   fsize = max 2^-f;
   If[aspectRatio==1,
   	MakeFilter[gaboranalyticoct,fsize,octaves
     	,fmax fsize/4.,or dor,0],
    MakeFilter[gaboranalyticoct,fsize,octaves
     	,fmax fsize/4.,or dor,0,aspectRatio]])
  ,{f,nlayers-1,0,-1},{or,0,nor-1}
]]























ApplyGaborArray[image_,array_, inDFT_:False, outDFT_:False,expand_:False] :=
Module[{pre,post},
pre = If[inDFT,Identity,InverseFourier];
post = If[outDFT,Identity,Fourier];
Map[ post[CombineDFT[#,pre[image],Times,expand]]&, array, {2}]
]





















ShowGaborArray[array_,prelayer_:Identity,zrange___List,opts___Rule] :=
 Show[GraphicsArray[Reverse[
 Map[GraphicsImage[prelayer[#],zrange]& ,array,{2}]]
 ],opts]





PadGaborArray[array_,n_:1] := Module[{blank},
 blank = Array[0.&,Dimensions[array[[1]]]];
 Join[array,Table[blank,{n}]]]

PadGaborArray[array_,parray_?MatrixQ] := Module[{blank},
 blank = Array[0.&,Dimensions[array[[1]]]];
 Join[array,Table[blank,{Subtract @@ (Length /@ {parray,array})}]]]

























































































MakeGaborFilterArray[size_, octaves_:1.
   , min_:8,  nor_:4, aspectRatio_:1] :=
 MakeGaborFilterArray[size, octaves, min, nor] =
 Module[{dor,nlayers,fsize},
  dor = N[Pi / nor];
  nlayers = 1+Floor[Log[2,size/min]];
  Table[(
   fsize = size 2^-f;
   If[aspectRatio==1,
	   MakeFilter[gaboranalyticoct,fsize,octaves
	     ,fsize/4.,or dor,0],
	   MakeFilter[gaboranalyticoct,fsize,octaves
	     ,fsize/4.,or dor,0,aspectRatio]])
  ,{f,nlayers-1,0,-1},{or,0,nor-1}
]]























ApplyGaborFilterArray::usage="ApplyGaborFilterArray[image_,array_, inDFT_:True, outDFT_:True,expand_:False]: Apply a two-dimensional array of Gabor Filters to an image. If expand is True, the elements of the output array are the same size as the image; otherwise, they are the same size as the filters. See MakeGaborFilterArray.";





ApplyGaborFilterArray[image_,array_, inDFT_:False, outDFT_:False,expand_:False] :=
Module[{pre,post},
pre = If[inDFT,Identity,InverseFourier];
post = If[outDFT,Identity,Fourier];
Map[ post[CombineDFT[#,pre[image],Times,expand]]&, array, {2}]
]

















