(* ::Package:: *)

(************************************************************************)
(* This file was generated automatically by the Mathematica front end.  *)
(* It contains Initialization cells from a Notebook file, which         *)
(* typically will have the same name as this file except ending in      *)
(* ".nb" instead of ".m".                                               *)
(*                                                                      *)
(* This file is intended to be loaded into the Mathematica kernel using *)
(* the package loading commands Get or Needs.  Doing so is equivalent   *)
(* to using the Evaluate Initialization Cells menu command in the front *)
(* end.                                                                 *)
(*                                                                      *)
(* DO NOT EDIT THIS FILE.  This entire file is regenerated              *)
(* automatically each time the parent Notebook file is saved in the     *)
(* Mathematica front end.  Any changes you make to this file will be    *)
(* overwritten.                                                         *)
(************************************************************************)



BeginPackage["ImageProcessing`"];


ShowImageRGB::usage ="ShowImageRGB[image_List,interleaved_:False,opts___Rule]: show a color image, where image is an array with dimensions {3,rows,cols}. If dimensions are {rows,cols,3}, use interleaved=True. ShowImage will also work for RGB images.";


BlockImage::usage="BlockImage[image_,blocksize_:{8,8}]: Partition an image into non-overlapping blocks of dimensions blocksize.";


UnBlockImage::usage="UnBlockImage[blockedImage_]: Reconstruct an image from equal-sized blocks.";


GraphicsImageRGB::usage="GraphicsImageRGB[image_List, interleaved_Symbol:False, opts___Rule]: create a RasterArray graphics object from an RGB color image. First row is at the bottom.RGB values are assumed to lie between 0 and 1.If color planes are interleaved (Dimensions[image] == {_,_,3}), then use interleaved=True. Options to Show such as PlotLabel and Axes can be used.See also GraphicsImage and ShowImageRGB.";


BlockAverage::usage="BlockAverage[image,blocksize]: Average pixel values over blocks of size blocksize={height,width}. BlockAverage[image,height,width] will also work.";


WritePBM::usage="WritePBM[image,file,color]: write a byte image to a PBM format file. This is a simple format that is readable by cjpeg (the JPEG compression software distributed by the Independent JPEG Group) and xv. color is either True or False, and defaults to True.See also: ReadPBM.";


ReadPBM::usage="ReadPBM[file]: read a byte image from a PBM format file. This is a simple format that is readable by cjpeg (the JPEG compression software distributed by the Independent JPEG Group) and xv. See also: WritePBM.";


WriteDIS::usage="WriteDIS[ sequence, file]: write a byte image sequence to a DIS format file. This is a simple format that is adapted from PBM, but capable of storing image sequences. sequence is assumed to have dimensions {frames,colors,rows,columns}, but bytes are stored in the order {frames, rows, columns, colors}. If the TensorRank of sequence is 3, a grayscale movie is written. See also: ReadDIS.";


ReadDIS::usage="ReadDIS[file]: read a byte image from a DIS format file. See also: WriteDIS.";


InterleaveColorMovie::usage="InterleaveColorMovie[movie]: Converts a movie from dimensions {frames, colors, rows, columns} to {frames, rows, columns, colors}. See also DeInterleaveColorMovie.";


DeInterleaveColorMovie::usage="DeInterleaveColorMovie[movie]: Converts a movie from dimensions {frames, rows, columns, colors} to {frames, colors, rows, columns}. See also DeInterleaveColorMovie.";


ReadByteImage::usage="ReadByteImage[file_,cols_,rows_,colors_:1,frames_:1]: Read a raw byte image or sequence of images from a file.Assumes that dimensions are in the order {frames, colors,rows,columns}, with frames and colors optional.";


ReadByteFile::usage="ReadByteFile[file_]: Read a file of bytes. See WriteByteFile[].";


WriteByteStream::usage="WriteByteStream[stream,data]: write byte data to a stream. Data are flattened before writing. Data are assumed to be of a type that can be represented by single bytes. The stream must first be opened with the function OpenWriteBinary (from the package Utilities`BinaryFiles). See also WriteByteFile, which opens and closes the stream, as well as writing the data.";


WriteByteFile::usage="WriteByteFile[file,data]: write byte data to a file. Data is flattened before writing. Data are assumed to be of a type that can be represented by single bytes. See also WriteByteStream, which neither opens nor closes the stream.";


GraphicsImage::usage="GraphicsImage[image]: create a raster graphics object from a greyscale image. First row is at the bottom.Image is scaled to use the full contrast range, unless a range is specified by GraphicsImage[image,range].Options to Show such as PlotLabel and Axes can be used.";


ShowImage::usage="ShowImage[image]: display a greyscale image. First row is at the bottom.Image is scaled to use the full contrast range, unless a range is specified by ShowImage[image,range]. Options to Show[] such as PlotLabel and Axes can be used. If the image argument has a TensorRank==3, then it will be displayed as either an RGB color image or an array of images. An RGB image will be displayed if either the first or third dimension is 3 and the second argument, if it exists, is a symbol. That symbol should be True if  that image consists of three arrays {R,G,B} and False if instead the RGB triples are at the lowest level in the list structure {{...{R,G,B}...}...}. Otherwise an array of images will be displayed. The number of images in each row is specified by ShowImage[images,columns], where columns defaults to Infinity (a single row).";


WrapImage::usage="WrapImage[array,shifts]: Wrap (scroll) an n-dimensional array (in the Cartesian-positive direction) by the corresponding shifts (which may be negative). Shifts default to half the corresponding dimension. Dimensions are specified in the order given by Dimensions[]. In 2 dimensions, shifts = {rows,columns}. Alternate form for a 2D image: WrapImage[image,rows,cols].";


Wrap::usage= "See WrapImage.";


ShowMovie::usage="ShowMovie[sequence]: Show a sequence of images. The resulting set of images can be animated using 'Animate Selected Graphics' from the Graph menu.ShowMovie[sequence,range] uses the specified intensity range, otherwise the full range of the sequence is used.";


PadImage::usage="PadImage[array,dimensions]: pad an n-dimensional array with zeros to dimensions.";


CutImage::usage="CutImage[image,point,size]: cut a rectangular region from an image. point is the upper left corner. point and size are specified as {row,col}. See also takeImage[]";


PasteImage::usage="PasteImage[imagesink,imagesource,point]: Paste (composite) the imagesource into the imagesink, placing the lower left hand corner of the source at point in the sink.";


ShowSpectrum::usage="ShowSpectrum[dft]: Display a 2D or 3D Fourier spectrum. Assumes a square, even DFT. To start from an image, use ShowSpectrum[ InverseFourier[image] ]. origin is at center, axes run up and right.To get axes, use ShowSpectrum[dft, {{xmin,xmax}, {ymin,ymax}}] . To specify a range of magnitudes, use ShowSpectrum[dft, {{xmin,xmax}, {ymin,ymax}, {zmin,zmax}}]  Other options as for Show may also be given." ;


ShowSpectrum2D::usage="ShowSpectrum2D[dft]: 2D Fourier spectrum. Assumes a square, even 2D dft. To start from an image, use
ShowSpectrum2D[ InverseFourier[image] ].
origin is at center, axes run up and right.To get axes, use ShowSpectrum2D[dft, {{xmin,xmax}, {ymin,ymax}}] . To specify a range of magnitudes, use ShowSpectrum2D[dft, {{xmin,xmax}, {ymin,ymax}, {zmin,zmax}}]  Other options as for Show may also be given." ;


ShowSpectrum3D::usage="ShowSpectrum3D[dft]: 3D Fourier spectrum. Assumes a square, even 3D dft. To start from sequence, use ShowSpectrum3D[ InverseFourier[sequence] ]. origin is at center, axes run up and right." ;


Convolve2DF::usage="Convolve2DF[image,kernel]: Circular convolution via frequency domain.Currently assumes image is larger or equal to kernel (obsolete, use ConvolveF).";


ConvolveF::usage="ConvolveF[array,kernel]: Circular convolution of two n-dimensional arrays via Discrete Fourier Transform.Currently assumes array is larger or equal to kernel.";


Convolve2D::usage="Convolve2D[image,kernel]: Circular convolution (direct in space domain).Not very efficient.";


CrossCorrelation::usage="CrossCorrelation[array1,array2]: Circular cross correlation of n-D arrays via frequency domain. Currently assumes Dimensions[image1] >= Dimensions[image2].";


NormalizedCrossCorrelation::usage="NormalizedCrossCorrelation[array1,array2]: Normalized circular cross correlation of n-D arrays via frequency domain. Currently assumes Dimensions[image1] >= Dimensions[image2].";


CrossCorr2DF::usage="CrossCorr2DF[image1,image2]: Circular cross correlation via frequency domain. Currently assumes image1 is larger or equal to image2. Obsolete, see CrossCorrF[].";


ReflectDFT::usage="ReflectDFT[list]: reflect (about the origin) an n-dimensional Discrete Fourier Transform. As usual, the origin is the first entry in the list. This function is useful for creating DFT's with conjugate (Hermite) symmetry. See also ReflectDFT1D.";


ReflectDFT1D::usage="ReflectDFT1D[list]: reflect (about the origin in the first dimension) an n-dimensional Discrete Fourier Transform. As usual, the origin is the first entry in the list. This function is useful for creating DFT's with conjugate (Hermite) symmetry. See also ReflectDFT.";


UpSample::usage="UpSample[array,steps,starts]: upsample (interpolate zeros) an n-dimensional array. steps is a list of sampling periods for each dimension, in the order they are given by Dimensions[]. starts is a list of starting coordinates (the location in the output of the first element in the input). UpSample[list,matrix,starts] where list is of dimension 1 and matrix is a 2x2 matrix, will perform a general periodic 2D up-sampling of the list; the output will be a 2D image. See DownSample[].";


DownSample::usage="DownSample[array,steps,starts]: down-sample an n-dimensional array. steps is a list of sampling periods for each dimension, in the order they are given by Dimensions[]. starts is a list of starting coordinates (the location in the input of the first element in the output). DownSample[image,matrix,starts] where image and matrix are of dimension 2, will perform a general periodic 2D sampling of the image; the output will be a 1D list. See UpSample[].";


bound::usage="bound[x_,min_:1,max_:255]: Convert to integer and clip to [max,min].";


CombineDFT::usage="CombineDFT[dft1_,dft2_,op_:Plus,expand_:False] combines DFTs of possibly different sizes using the specified operation op. If expand==TRUE, output is size of the larger, otherwise it is size of the smaller. Currently assumes square, even, DFTs.";


Clip::usage="Clip[x_,min_:0,max_:255,ToInteger_:False] Clip a number to between min and max. x may be an array. If any element of x is Real, or if ToInteger is False, real numbers will be returned, otherwise integers.";


ClipImageRGB::usage="ClipImageRGB[image_,min_:0.0,max_:1.0] Clip a real RGB image to between min and max.";


PixRep::usage="PixRep[image_,dim_] Enlarge an image by pixel replication. dim is a list of enlargement factors (including possibly 1), in the same order as returned by Dimensions[] (columns last). This currently only works for images of TensorRank 2.";


TakeArray::usage="TakeArray[list_,dim_] Extract an array of dimensions dim from list. TakeArray[list_,dim_,start_] Begin at start.";


Energy::usage="Energy[image_] Compute energy of an image.";


Begin["`Private`"];


Off[RasterArray::"obs"]


GraphicsImage[image_] := GraphicsImage[image,{Min[image],Max[image]}]


GraphicsImage[image_,zrange_]:=Module[{dims=Reverse[Dimensions[image]]},Graphics[Raster[image,{{0,0},dims},zrange],ImageSize->dims,AspectRatio->1/Divide@@dims,PlotRange->Transpose[{{0,0},dims}],PlotRegion->{{0,1},{0,1}}]]


ShowImage[image_?(TensorRank[#]==3 && Length[#] == 3&),opts___Rule]:=
  ShowImageRGB[image,False,opts]


ShowImage[image_?(TensorRank[#]==3 && Length[#[[1,1]]] == 3&),opts___Rule]:=
  ShowImageRGB[image,True,opts]


ShowImage[image_?(TensorRank[#]==3 &&
  (Length[#[[1,1]]] == 3 || Length[#] == 3)&)
  ,interleaved_Symbol,opts___Rule]:=
  ShowImageRGB[image,interleaved,opts]


ShowImage[image_?(TensorRank[#]==3&), columns_:Infinity, opts___Rule]:=
  Show[ GraphicsArray[
  If[columns != Infinity,
  Partition[#,columns]&,Identity][
  GraphicsImage /@ image]], opts]


ShowImage[image_?(TensorRank[#]==3&), columns_:Infinity, zrange_List, opts___Rule]:=
  Show[ GraphicsArray[
  If[columns != Infinity,
  Partition[#,columns]&,Identity][
  GraphicsImage[#,zrange]& /@ image]], opts]


ShowImage[image_?(TensorRank[#]==4&),opts___Rule]:=
  Show[ GraphicsArray[
 Map[ GraphicsImage, image,{-3}]], opts]


ShowImage[image_List, opts___Rule]:=
 Show[ GraphicsImage[image], opts]


ShowImage[image_List,zrange_List,opts___Rule]:=
  Show[ GraphicsImage[image,zrange], opts]


ShowImageRGB[image_List,interleaved_Symbol:False,opts___Rule] :=
 Show[Graphics[RasterArray[Apply[RGBColor,
   If[interleaved,
     image
    ,Transpose[image,{3,1,2}] ]
 ,{-2}]]]
 ,opts
 ,AspectRatio->Automatic]


GraphicsImageRGB[image_List, interleaved_Symbol:False, opts___Rule] := 
  Graphics[RasterArray[Apply[RGBColor, 
    If[interleaved, image, 
      Transpose[image, {3, 1, 2}]], {-2}]]
       ,opts, AspectRatio -> Automatic]


ShowMovie[sequence_,opts___Rule] := Module[{r},
	r = {Min[sequence],Max[sequence]};
 ShowImage[#,r,opts]& /@ sequence ];


ShowMovie[sequence_,range_List,opts___Rule] :=
 ShowImage[#,range,opts]& /@ sequence


zero[array_] := Map[0&, array, {-1}]


WrapImage[array_List,shifts_List]:= Module[{i,tmp=array},
 Do[tmp = Map[ RotateRight[#, shifts[[i+1]] ]&
   , tmp , {i}], {i,0,TensorRank[array]-1} ];
 tmp ]


WrapImage[array_?(TensorRank[#]>2&)] := WrapImage[array,Round[Dimensions[array]/2] ]


WrapImage[image_,rows_,cols_ ] :=
 Map[ RotateRight[# , cols ]& ,
       RotateRight[ image, rows ] ]


WrapImage[array_] := WrapImage[array,##]& @@ Round[Dimensions[array]/2]


WrapImage[array_?VectorQ] :=
 RotateRight[array, Round[Dimensions[array]/2]]


Wrap := WrapImage


PadImage[array_List, dimensions_List ] := Module[
 {ddim,tmp=array,indices,tr = TensorRank[array]},
 indices = RotateRight[Range[tr]];
 ddim = dimensions-Dimensions[array];
 Do[
   tmp = Transpose[ Join[tmp
      , Table[zero[ tmp[[1]] ],{ddim[[i]]} ] ], indices ]
  ,{i,tr} ];
 tmp ]
 (* need Fold[] from version 2.0 *)


PixRep[image_,dim_:{2,2}] :=
 Fold[Partition,Flatten[Transpose[
  Array[image&,dim],
   {2, 4, 1, 3} ] ],
Reverse[Drop[ Dimensions[image] dim , 1 ] ] ]


PixRep[image_,{1,1}] :=  image


CutImage[image_,point_,size_] :=
  image[[
    Range[point[[1]] , point[[1]] + size[[1]] - 1 ]
   ,Range[point[[2]] , point[[2]] + size[[2]] - 1 ]
  ]]


TakeArray[list_,dim_] :=
 Fold[Transpose[Take[#1,#2]]& , list, dim ]


TakeArray[list_,dim_,start_] := 
 Fold[Transpose[Take[#1,#2]]& , list,
  Transpose[{start,start+dim-1}] ]


PasteImage[imagesink_,imagesource_,point_List:{1,1}] :=
	Module[{i,rows,cols,irows,icols,row,col},
	{irows,icols} = Dimensions[imagesink];
	{rows,cols} = Dimensions[imagesource];
	{row,col} = point;
	Join[
	 Take[imagesink,row-1],
	 Table[
	  Join[Take[imagesink[[i+row-1]],col-1]
	      ,Take[imagesource[[i]],cols]
	      ,Take[imagesink[[i+row-1]],-(icols-cols-col+1)]]
	 ,{i,rows}],
	Take[imagesink,-(irows-rows-row+1)]]
	]
	(* yecch ! *)


Energy[image_] := Plus @@ Flatten[Abs[image]^2]


InterleaveColorMovie[movie_] :=
	Transpose[movie,{1,4,2,3}]


DeInterleaveColorMovie[movie_] :=
	Transpose[movie,{1,3,4,2}]


BlockImage[image_,blocksize_:{8,8}] :=
	Partition[image,blocksize]


UnBlockImage[blockedImage_] :=
 Module[{cols},
 cols= Dimensions[blockedImage];
 cols = cols[[2]] cols[[4]];
	 Partition[Flatten[Transpose[
   blockedImage
  ,{1,3,2}]],{cols}] ]


Clipping[x_,min_:0,max_:255,ToInteger_:False] := If[ListQ[x],
  (func = Which[ToInteger,clipC2I
             ,MemberQ[x,_Real,Infinity],clipC
             ,True,clipCI];
   Map[func[#,min,max]&,x,{-1}]),
  Which[ToInteger,clipC2I
             ,IntegerQ[x],clipCI
             ,True,clipC][x,min,max]]


Off[General::"spell"]


clipC = Compile[{x,min,max},
 Which[x > max, max, x < min, min, True, x] ];


clipCI = Compile[{{x,_Integer},{min,_Integer},{max,_Integer}},
 Which[x > max, max, x < min, min,True,x] ];


clipC2I = Compile[{x,{min,_Integer},{max,_Integer}},
 Max[Min[Round[x],max],min]];


On[General::"spell"]


bound[x_,min_:1,max_:255] :=
 Which[# > max, max, # < min, min,True,# ]&[Round[x]]


SetAttributes[bound,Listable];


ClipImageRGB[image_,min_:0.0,max_:1.0] := 
    (Print["please change ClipImageRGB to Clip"];
    Clipping[image,min,max])


UpSample1D[list_List,step_:2,start_:1] :=
 Flatten[Transpose[RotateRight[Prepend[
  Table[ 0 list[[1]],{step-1},{Length[list]}]
  ,list],start-1]],1]


UpSample[array_List,steps_?(TensorRank[#]==1&),starts_List] :=
	Module[{indices, tr = TensorRank[array],tmp=array,i}, 
  indices = RotateRight[Range[tr]]; 
  Do[tmp =
   Transpose[UpSample1D[tmp,steps[[i]],starts[[i]] ]
    ,indices ]
  ,{i,tr} ];
  tmp]
(* need Fold[] from version 2.0 ! *)


DownSample[array_List,steps_?(TensorRank[#]==1&),starts_List] :=
 Part @@ Prepend[Table[Range[starts[[i]]
  ,Dimensions[array][[i]]
  ,steps[[i]]]
  ,{i,TensorRank[array]}],array]


DownSample[array_List] := DownSample[array
 ,Table[2,{TensorRank[array]} ]
 ,Table[1,{TensorRank[array]} ] ]


BlockAverage[image_,blocksize_] :=
 Map[ (Plus @@ Flatten[#])&,
  BlockImage[image,blocksize], {2}] /
    (Times @@ blocksize)


BlockAverage[image_,{1,1}] := image


BlockAverage[image_,height_,width_] :=
 BlockAverage[image,{height,width}]


sampleLoc[size_,matrix_?MatrixQ,origin_:{1,1}] := Module[
 {row,col,newcols},
	If[IntegerQ[newcols = size / Abs[Det[matrix]]],
  Flatten[Table[
    1 + Mod[ origin - 1 + matrix . {col,row} , size]
   ,{row,0,size-1}
   ,{col,0,newcols-1}
   ],1] ,
  Return["Error in sampleLoc: number of image columns not divisible by Det[matrix]"]
   ]
 ]


DownSample[image_?MatrixQ,matrix_?MatrixQ,origin_:{1,1}] :=
 image[[ #[[2]],#[[1]] ]]& /@ 
    sampleLoc[ Length[image] , matrix ,origin]


UpSample[list_List,matrix_?MatrixQ,origin_:{1,1}] := Module[
 {i,rows,image,locs},
	rows = Sqrt[Length[list] Abs[Det[matrix]]];
	image = Table[0,{rows},{rows}];
	locs = sampleLoc[ rows , matrix ,origin];
 Do[image[[ locs[[i,2]] ,locs[[i,1]] ]] = list[[i]]
  ,{i,Length[list]}];
 image
  ]


ShowSpectrum[dft_?MatrixQ, opts___Rule] :=
    ShowImage[ WrapImage[ Abs[ dft ] ] , opts]


ShowSpectrum[dft_?MatrixQ,ranges_List,opts___Rule] := 
	Module[{tmp,xyrange,zrange},
	xyrange = Transpose[Reverse[ranges[[{1,2}]]]];
	tmp = WrapImage[ Abs[ dft ] ];
	zrange	=	If[	Length[ranges]==3,	ranges[[3]]
		,{Min[tmp],Max[tmp]}];
	Show[Graphics[Raster[ tmp,xyrange,zrange] ]
	 ,opts
	 ,Axes->Automatic
	 ,Frame->True
	 ,AspectRatio->
	    1/Divide @@ ( 1 - Subtract @@ xyrange)
	 ,AxesOrigin->xyrange[[1]]
 ] ]


ShowSpectrum[dft_, opts___Rule] :=
  ShowMovie[ WrapImage[ Abs[dft] ], opts ]


ShowSpectrum[dft_,zrange_:0] := Module[{tmp,range},
 tmp = WrapImage[Abs[dft]];
 range= If[ListQ[zrange],
    zrange,{Min@#,Max@#}&[tmp]];
 Show[GraphicsArray[GraphicsImage[#,range]& /@ tmp]]]


CombineDFT[dft1_,dft2_,op_:Plus,expand_:False] := Module[
 {dif,le1,le2,tmp},
 le1 = Length[dft1];
 le2 = Length[dft2];
 dif = le1- le2;
 If[dif == 0, op[dft1,dft2],
  If[expand,
   If[dif > 0,
   
    (tmp=Transpose[PadImage[WrapImage[dft2],{le1,le1}]];
     tmp[[le2+1]] = tmp[[1]];
     tmp = Transpose[tmp];
     tmp[[le2+1]] = tmp[[1]];
     op[dft1,WrapImage[tmp,-le2/2,-le2/2]]),

    (tmp=Transpose[PadImage[WrapImage[dft1],{le2,le2}]];
     tmp[[le1+1]] = tmp[[1]];
     tmp = Transpose[tmp];
     tmp[[le1+1]] = tmp[[1]];
     op[WrapImage[tmp,-le1/2,-le1/2],dft2])
   ] ,

  If[dif > 0,
    op[WrapImage[CutImage[WrapImage[dft1],{1+dif/2,1+dif/2}
     ,{le2,le2}]],dft2],
    op[dft1,WrapImage[CutImage[WrapImage[dft2], 
       {1-dif/2,1-dif/2},{le1,le1}] ] ]
   ]
 ] ] ] 


ReflectDFT[ndft_List]:=
 Map[RotateRight[Reverse[#],1]&
   , ndft , {0,TensorRank[ndft]-1} ]


ReflectDFT1D[ndft_List]:=
 RotateRight[Reverse[ndft],1]


ConvolveF[array_,kernel_] := Module[ {newDim},
 newDim = Max /@ Transpose[
    Dimensions /@ {array,kernel}];
 Chop[
   N[Sqrt[ Times @@ newDim ] ] *
    Fourier[ Times @@
     (InverseFourier[WrapImage[PadImage[WrapImage[#],newDim],-Dimensions[#]/2]]& /@
       {array,kernel}) ]
 ] ]


Convolve2D[image_,kernel_] := Module[ {i,j,cols, rows,tmp},
   {rows, cols} = Dimensions[kernel];
   Apply[ Plus,
       Table[ kernel[[i,j]] WrapImage[image,i-1,j-1 ] 
        ,{j,cols}, {i,rows} ]
   ,{0,1}]
]


CrossCorrelation[image1_,image2_] := Module[ {dim},
 dim = Dimensions[image1];
 Chop[
  N[Sqrt[ Times @@ dim ] ] *
    Fourier[
      Conjugate[InverseFourier[ image1 ] ] *
        InverseFourier[  PadImage[ image2, dim ]  ]
 ] ] ]


NormalizedCrossCorrelation[image1_,image2_] :=  
 CrossCorrelation[image1,image2] /
  Sqrt[Times @@ (Energy /@ {image1,image2})]


WriteByteStream[stream_,data_] :=
 WriteBinary[stream,Flatten[data],
             ByteConversion->Identity]


WriteByteFile[file_,data_] :=  Module[{stream},
 stream=OpenWriteBinary[file];
 WriteByteStream[stream,data];
 Close[stream];]


ReadByteFile[file_] := ReadList[file,Byte]


ReadByteImage[file_,cols_,rows_:1,colors_:1,frames_:1] := Module[{parts},
	parts={cols};
	If[colors > 1 ,
	 If[frames > 1, parts=Join[parts,{rows,colors}]
	  , AppendTo[parts,rows] ]
	 ,If[frames > 1, AppendTo[parts,rows] ] ];
	Fold[Partition, ReadList[file,Byte],parts ] ]


WritePBM[ image_, file_, color_:True ] :=  
 Module[{stream,rows,columns},Print["WritePBM disabled for MMA 5.1."];Abort[];
 stream=OpenWrite[file];
 {rows,columns}=ToString /@
       Take[Dimensions[image],-2];
 WriteString[stream,
  If[color,"P6","P5"]<>
  "\n"<>columns<>" "<>rows<>"\n255\n"];
 WriteBinary[stream,
   Flatten[If[color,Transpose[image,{3,1,2}],image]],
     ByteConversion->Identity];
 Close[stream];]


ReadPBM[ file_ ] :=
 Module[{stream,type,tmp,columns,rows,rw},
 rw := Read[stream , Word
   ,WordSeparators->{"
","
"," "}];
 stream = OpenRead[file];
 type = rw;
 {columns,rows} = ToExpression /@ {rw,rw};
 rw;Read[stream , Character];
	tmp = If[type == "P6"
	 ,Transpose[Fold[Partition
	    , ReadList[stream,Byte],{3,columns} ], {2,3,1}]
	 ,Fold[Partition,ReadList[stream,Byte],{columns}]];
 Close[stream];
 tmp]


WriteDIS[ sequence_, file_ ] :=
 Module[{stream,frames,rows,columns,color},
 color = (TensorRank[sequence]==4);
 stream=OpenWrite[file];
 tmp = ToString /@ Dimensions[sequence];
 {frames,rows,columns} = If[color,tmp[[{1,3,4}]],tmp];
 WriteString[stream,
  If[color,"P6","P5"]<>
  "\n"<>columns<>" "<>rows<>" "<>frames<>"\n255\n"];
 WriteBinary[stream,
 	Flatten[
 		If[color,
 			InterleaveColorMovie[Map[Reverse,sequence,{2}]],
 			Reverse /@ sequence]],
 	ByteConversion->Identity];
 Close[stream];]


ReadDIS[ file_ ] :=
 Module[{stream,type,tmp,columns,rows,frames,rw},
 rw := Read[stream , Word
   ,WordSeparators->{"
","
"," "}];
 stream = OpenRead[file];
 type = rw;
 {columns,rows,frames} = ToExpression /@ {rw,rw,rw};
 rw;Read[stream , Character];
 tmp = ReadList[stream,Byte];
 tmp = If[type == "P6",
	Map[Reverse,#,{2}]& @
	 DeInterleaveColorMovie[Fold[Partition,tmp ,{3,columns,rows}]] ,
	Reverse /@ Fold[Partition,tmp,{columns,rows}]];
 Close[stream];
 If[Dimensions[tmp] != If[type == "P6",{frames,3,rows,columns},{frames,rows,columns}],
 	(Print["ReadDIS: Header dimensions",
 	{frames,rows,columns},
 	"do not match files size",
 	ToString[Dimensions[tmp]]];Abort[])];
 tmp]


End[];


EndPackage[];
