(* ::Package:: *)

(************************************************************************)
(* This file was generated automatically by the Mathematica front end.  *)
(* It contains Initialization cells from a Notebook file, which         *)
(* typically will have the same name as this file except ending in      *)
(* ".nb" instead of ".m".                                               *)
(*                                                                      *)
(* This file is intended to be loaded into the Mathematica kernel using *)
(* the package loading commands Get or Needs.  Doing so is equivalent   *)
(* to using the Evaluate Initialization Cells menu command in the front *)
(* end.                                                                 *)
(*                                                                      *)
(* DO NOT EDIT THIS FILE.  This entire file is regenerated              *)
(* automatically each time the parent Notebook file is saved in the     *)
(* Mathematica front end.  Any changes you make to this file will be    *)
(* overwritten.                                                         *)
(************************************************************************)



Off[General::spell1];


PointBarLine[data_] := {
 {Point /@#,Line@#}& @ (Take[#,2]& /@ data),
 Line /@ (
  (#/. {a_,b_,c_}->{{a,b+c},{a,b-c}})& /@ data)}


PointBarLine[data_] :=
PointBarLine[Transpose[Join[{Range[Length[data]]},Transpose[data]]]] /; (Length[First[data]]==2)


ReadTable[file_,rowLength_] := Module[{tmp},
 tmp = ReadList[ file, Word
 ,WordSeparators->{"\t","\n"}
 ,RecordLists->True, RecordSeparators->{"\n"}
 ,NullWords->True];
 Take[#,rowLength]& /@ tmp]


ReadTable[file_] :=
 Drop[ ReadList[ file, Word
 ,WordSeparators->{"\t","\n"}
 ,RecordLists->True, RecordSeparators->{"\n"}
 ,NullWords->True],-1]


IndexMin[list_] :=
 First[Flatten[Position[list, Min[list]]]]


IndexMax::usage = "IndexMax[list_]: This utility function returns the index of the largest element in a list (in the case of a tie, it returns the first of the winners).";


IndexMax[list_] := First[Flatten[Position[list,Max[list]]]]


Timer[1] := Timer[2] = SessionTime[]


Timer[0] := SessionTime[] - Timer[2]


ElapsedTime[label_] := (Print[{label,Timer[0]}];Timer[1])


Shuffle[list_] := Module[{length,tmp,i,j,y},
	length = Length[list];
	tmp = list;
	Do[
		j = Random[Integer,{1,length}];
		y = tmp[[ i ]];
		tmp[[ i ]] = tmp[[ j ]];
		tmp[[ j ]] = y;
		, {i, length }];
	tmp ]


ShuffleArray[array_] :=
Fold[Partition,shuffle[Flatten[array]],Reverse[Drop[Dimensions[array],1]]]


l10[x_] := Log[10,x]


normalize[list_] := Module[{min,max},
 min = Min[list];
 max = Max[list];
 (list - min)/(max-min) ]


hilbert[list_] := Module[{half},
	half = Floor[Length[list]/2];
	list RotateRight[Table[-I Sign[u],{u,-half,half-1}] ,half]]


frep[list_] := RotateRight[list,Length[list]/2]


energy[list_] := Plus @@ (Abs[Flatten[ list ]]^2)


indexReflect[n_,length_] := 1 + Mod[1-n,length]


dB[x_] := 20. Log[10.,x]


dBinv[x_] := 10.^( x .05)


dBInverse[x_] := 10.^( x .05)


TransformShape[shape_, matrix_] := Module[
	{poly,line,point},
   shape /. 
    {poly:Polygon[_] :> 
      Map[matrix . #1 & , poly, {2}], 
     line:Line[_] :> 
      Map[matrix . #1 & , line, {2}], 
     point:Point[_] :> 
      Map[matrix . #1 & , point, {1}]} ]


ClearOut[] := (
 Unprotect[Out];Clear[Out];Protect[Out];
 MemoryInUse[] 10^-6 //N )


MBytesInUse[] := MemoryInUse[] 10^-6 //N


HalfRectify[x_?Negative] := 0


HalfRectify[x_] := x


SetAttributes[HalfRectify,Listable];


AverageDuplicates[list_] := Module[{n,l,tmp=list},
 l=Length[tmp];
 n=1;
 While[n<l,
  If[tmp[[n,1]]==tmp[[n+1,1]],
    tmp[[n]]=(tmp[[n]]+tmp[[n+1]])/2.;
    tmp=Drop[tmp,{n+1}];
    l--];
  n++];
 tmp]


ArgumentNames[f_] := ToString /@ 
 Function[patt,
  Cases[patt,
	  p_Pattern :> HoldForm @@ HeldPart[p, 1],
	   {0, Infinity},Heads->True]
	   ][#[[1]]]& /@ DownValues[f]


MeanABW[list_] := ((Plus @@ #)/Length[#])& @
 Select[list,NumberQ]


dPrime2PC[dprime_,M_:2]:=Module[{g,G},g[x_]:=Sqrt[1/(2*Pi)]*E^(-x^2/2);G[x_]:=Integrate[g[y],{y,-Infinity,x}];100NIntegrate[N[g[x-dprime]*G[x]^(M-1)],{x,-Infinity,Infinity},AccuracyGoal->2]]



