(* ::Package:: *)

(************************************************************************)
(* This file was generated automatically by the Mathematica front end.  *)
(* It contains Initialization cells from a Notebook file, which         *)
(* typically will have the same name as this file except ending in      *)
(* ".nb" instead of ".m".                                               *)
(*                                                                      *)
(* This file is intended to be loaded into the Mathematica kernel using *)
(* the package loading commands Get or Needs.  Doing so is equivalent   *)
(* to using the Evaluate Initialization Cells menu command in the front *)
(* end.                                                                 *)
(*                                                                      *)
(* DO NOT EDIT THIS FILE.  This entire file is regenerated              *)
(* automatically each time the parent Notebook file is saved in the     *)
(* Mathematica front end.  Any changes you make to this file will be    *)
(* overwritten.                                                         *)
(************************************************************************)



(* ::Input::Initialization:: *)
PsychometricaStyles={Frame->True,BaseStyle->{12,FontFamily->"Helvetica"},ImageSize->{Automatic,240}};


(* ::Input::Initialization:: *)
Off[General::munfl];Off[CompiledFunction::cfsa]


(* ::Input::Initialization:: *)
If[Names["MinMax"]=={},MinMax::usage = "MinMax[list_]: Returns a list {min,max} of the largest and smallest entries in the list.";MinMax[list_List] := {Min[list],Max[list]}]


(* ::Input::Initialization:: *)
dB[x_] := 20 Log[10,x]


(* ::Input::Initialization:: *)
dBInverse[x_]:=10 ^(x /20)


(* ::Input::Initialization:: *)
PlotPF::usage = "PlotPF[function_,thlist_ ,slopelist_]: This utility function shows a plot of a specified psychometric function and allows the user to explore different parameters. The first argument is the name of the function. The second argument is a list {min,max,start) for threshold, and the third is a similar list for slope. The green arrows show the location of threshold, and the probability when strength equals threshold. The red arrows show the strength required to achieve a selected probability. This is obtained using the inverse psychometric function.";


(* ::Input::Initialization:: *)
PlotPF[fn_,thlist_ ,slopelist_] :=
 Manipulate[
(target0=fn[threshold,{threshold,slope,guess,lapse}];
strength0=fn[target,{threshold,slope,guess,lapse},True];
Plot[fn[x,{threshold,slope,guess,lapse}],{x,thlist[[1]],thlist[[2]]},PlotRange->{0,1}
,FrameLabel->{"Strength","Probability"}
,PlotLabel->ToString[fn]
,Evaluate@PsychometricaStyles
,Epilog->{Green
,Point[{threshold,target0}]
,Arrow[{{threshold,target0},{thlist[[1]],target0}}]
,Arrow[{{threshold,target0},{threshold,0}}]
,Text["threshold target = "<>ToString[NumberForm[N@target,2]],{thlist[[1]],target0},{-1.1,-2}]
,Text["threshold = "<>ToString[NumberForm[N@threshold,2]],{threshold ,.2},{-1.2,0}]
,Red
,Point[{strength0,target}]
,Arrow[{{strength0,target},{thlist[[2]],target}}]
,Arrow[{{strength0,target},{strength0,0}}]
,Text["target = "<>ToString[NumberForm[N@target,2]],{thlist[[2]],target},{1.1,-2}]
,Text["strength = "<>ToString[NumberForm[N@strength0,2]],{strength0 ,.1},{-1.2,0}]}])
,{{threshold,thlist[[3]]},thlist[[1]],thlist[[2]]}
,{{slope,slopelist[[3]]},slopelist[[1]],slopelist[[2]]}
,{{guess,0},0,.5}
,{{lapse,0},0,.5}
,{{target,target0},0,1}
,ContinuousAction->True]


(* ::Input::Initialization:: *)
TimingPF[fn_,p_, min_,max_,n_:10000] := Block[{result},
{Timing[result=fn[N@Range[min,max,(max-min)/n],p]][[1]],
Total[result]}]


(* ::Input::Initialization:: *)
IndexMin[list_] :=
 First[Flatten[Position[list, Min[list]]]]


(* ::Input::Initialization:: *)
IndexMax::usage = "IndexMax[list_]: This utility function returns the index of the largest element in a list (in the case of a tie, it returns the first of the winners).";


(* ::Input::Initialization:: *)
IndexMax[list_] := First[Flatten[Position[list,Max[list]]]]


(* ::Input::Initialization:: *)
ArgumentNames[f_] :=( ToString /@ 
Function[patt,
  Cases[patt,
	  p_Pattern :> HoldForm @@ HeldPart[p, 1],
	   {0, Infinity},Heads->True]
	   ][#[[1]]])& /@ DownValues[f]


(* ::Input::Initialization:: *)
WeibullPF::usage = "WeibullPF[strength_, {threshold_, slope_, guess_, lapse_}, inverse_:False]: This is a psychometric function based on the Weibull probability distribution. The stimulus strength is \!\(\*
StyleBox[\"x\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\".\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\" \",\nFontSlant->\"Italic\"]\)Threshold is the strength at which some target probability is obtained. Slope is a measure of the steepness of the function in the neighborhood of threshold. Guess, is the lower asymptotic probability,and lapse is the probability of an error at very high strength, that is, 1 minus the upper asymptotics probability. If inverse is True, it computes the inverse psychometric function: given a probability p, it returns the stimulus strength.";


(* ::Input::Initialization:: *)
WeibullPF[strength_,{threshold_,slope_,guess_,lapse_},inverse_:False] :=  
 guess + (1-guess-lapse) CDF[WeibullDistribution[slope,threshold],strength]


(* ::Input::Initialization:: *)
WeibullPF[p_,{threshold_,slope_,guess_,lapse_},True] := threshold (Log[(-1+guess+lapse)/(-1+lapse+p)]^(1/slope))


(* ::Input::Initialization:: *)
LogWeibullPF::usage = "LogWeibullPF[strength_,{threshold_,slope_,guess_,lapse_}]]: This is a psychometric function based on the Weibull probability distribution, where strength and threshold are defined in decibels. \!\(\*
StyleBox[\" \",\nFontSlant->\"Italic\"]\)Threshold is the strength at which some target probability is obtained. Slope is a measure of the steepness of the function in the neighborhood of threshold. Guess is the lower asymptotic probability,and lapse is the probability of an error at very high strength, that is, 1 minus the upper asymptotics probability. If inverse is True, it computes the inverse psychometric function: given a probability p, it returns the stimulus strength.";


(* ::Input::Initialization:: *)
LogWeibullPF[x_,{threshold_,slope_,guess_,lapse_},inverse_:False] :=  
guess + (1.-guess-lapse) (1.-Exp[- (dBInverse[x - threshold]) ^ slope])


(* ::Input::Initialization:: *)
LogWeibullPF[p_,{threshold_,slope_,guess_,lapse_},True] := threshold+Log[Log[(-1+guess+lapse)/(-1+lapse+p)]^(20/slope)]/Log[10]


(* ::Input::Initialization:: *)
LogWeibullPF1[strength_,{threshold_,slope_,guess_,lapse_},inverse_:False] :=
guess+(1.-guess-lapse)CDF[GumbelDistribution[threshold,20./(slope Log[10.])],strength]


(* ::Input::Initialization:: *)
LogisticPF::usage = "LogisticPF[strength_, {threshold_, slope_, guess_, lapse_}]: This is a psychometric function based on the Logistic probability distribution.  Threshold is the strength at which some target probability is obtained. Slope is a measure of the steepness of the function in the neighborhood of threshold. Guess is the lower asymptotic probability,and lapse is the probability of an error at very high strength, that is, 1 minus the upper asymptotics probability. If inverse is True, it computes the inverse psychometric function: given a probability p, it returns the stimulus strength.";


(* ::Input::Initialization:: *)
LogisticPF[strength_,{threshold_,slope_,guess_,lapse_},inverse_:False]:=  
 guess + (1 - guess - lapse) CDF[LogisticDistribution[threshold,1/slope],strength]


(* ::Input::Initialization:: *)
LogisticPF[p_,{threshold_,slope_,guess_,lapse_},True] := (slope threshold+Log[(guess-p)/(-1+lapse+p)])/slope


(* ::Input::Initialization:: *)
NormalPF::usage = "NormalPF[strength_,{threshold_,slope_,guess_,lapse_}]: The NormalPF psychometric function is the cumulative distribution function of a Normal density with mean threshold and standard deviation 1/slope. The stimulus strength is x. The guessing rate is guess, the lapsing rate is lapse. If inverse is True, it computes the inverse psychometric function: given a probability p, it returns the stimulus strength.";


(* ::Input::Initialization:: *)
NormalPF[strength_,{threshold_,slope_,guess_,lapse_},inverse_:False] := guess+(1-guess-lapse) CDF[NormalDistribution[threshold,1/slope],strength]


(* ::Input::Initialization:: *)
NormalPF[p_,{threshold_,slope_,guess_,lapse_},True] := threshold-Sqrt[2] (1/slope) InverseErfc[(2 (guess-p))/(-1+guess+lapse)]


(* ::Input::Initialization:: *)
CNormalPF::usage = "CNormalPF[strength_, {mean_, sd_, guess_, lapse_}]: The CNormalPF psychometric function is the cumulative distribution function of a Normal density with mean \!\(\*
StyleBox[\"mean\",\nFontSlant->\"Italic\"]\) and standard deviation \!\(\*
StyleBox[\"sd\",\nFontSlant->\"Italic\"]\). The stimulus strength is \!\(\*
StyleBox[\"strength\",\nFontSlant->\"Italic\"]\). The guessing rate is \!\(\*
StyleBox[\"guess\",\nFontSlant->\"Italic\"]\), the lapsing rate is \!\(\*
StyleBox[\"lapse\",\nFontSlant->\"Italic\"]\). The function returns a probability of success.";


(* ::Input::Initialization:: *)
CNormalPF[strength_,{mean_,sd_,guess_,lapse_},inverse_:False] := NormalPF[strength,{mean,1/sd,guess,lapse}]


(* ::Input::Initialization:: *)
CNormalPF[p_,{mean_,sd_,guess_,lapse_},True] := mean-Sqrt[2] sd InverseErfc[(2 (guess-p))/(-1+guess+lapse)]


(* ::Input::Initialization:: *)
CNormalPFInverse[p_,{mean_,sd_,guess_,lapse_}] := CNormalPF[p,{mean,sd,guess,lapse},True]


(* ::Input::Initialization:: *)
UniformPF::usage = "UniformPF[strength_,{threshold_,slope_,guess_,lapse_}]: The UniformPF psychometric function is based on the cumulative uniform distribution of width 1/slope, centered at threshold, ammended by guessing and lapsing parameters. It represents a linear increase in probability from a lower asymptote of \!\(\*
StyleBox[\"quess\",\nFontSlant->\"Italic\"]\) to an upper asymptote of 1-\!\(\*
StyleBox[\"lapse\",\nFontSlant->\"Italic\"]\), with a rate of increase of \!\(\*
StyleBox[\"(\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"1\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\" \",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"-\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\" \",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"guess\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\" \",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"-\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\" \",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"lapse\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\")\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"*\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"slope\",\nFontSlant->\"Italic\"]\). At \!\(\*
StyleBox[\"threshold\",\nFontSlant->\"Italic\"]\), the probability is \!\(\*
StyleBox[\"(\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"1\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\" \",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"+\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\" \",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"guess\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\" \",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"-\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\" \",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"lapse\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\")\",\nFontSlant->\"Italic\"]\)\!\(\*
StyleBox[\"/\",\nFontSlant->\"Italic\"]\)\*
StyleBox[\(\!\(\*
StyleBox[\"2\",\nFontSlant->\"Italic\"]\) .\)] If inverse is True, it computes the inverse psychometric function: given a probability p, it returns the stimulus strength.";


(* ::Input::Initialization:: *)
UniformPF[strength_,{threshold_, slope_, guess_, lapse_},inverse_:False] :=
guess + (1 - guess - lapse) CDF[UniformDistribution[threshold +{-1,1}/2/slope],strength]


(* ::Input::Initialization:: *)
UniformPF[p_,{threshold_, slope_, guess_, lapse_},True] :=
(1+guess-lapse-2 p)/(2 (-1+guess+lapse) slope)+threshold


(* ::Input::Initialization:: *)
PsychometricFunction::usage = "PsychometricFunction[strength_, {threshold_, slope_, guess_, lapse_}, opts___Rule]: The psychometric function defines the probability of being correct in a psychophysical task as a function of signal strength. The function is based on the cumulative probability distribution, modified by guessing and lapsing probabilities. The distribution can be specified by the Distribution option, which degaults to WeibullDistribution.   Threshold is the strength at which some target probability is obtained. Slope is a measure of the steepness of the function in the neighborhood of threshold. Guess, is the lower asymptotic probability, and lapse is the probability of an error at very high strength, that is, 1 minus the upper asymptotics probability. The option StrengthFunction specifies how to transform from strength and threshold specified in some new units to the standard units. For example, if strength and threshold are specified in dB, the use StrengthFunction\[Rule]dBInverse.";


(* ::Input::Initialization:: *)
Options[PsychometricFunction] = {Distribution->WeibullDistribution,StrengthFunction->Identity};


(* ::Input::Initialization:: *)
PsychometricFunction[strength_,{threshold_, slope_, guess_, lapse_},opts___Rule] := Block[{distribution,parameters,sfunction},
{distribution,sfunction} = {Distribution,StrengthFunction} /. {opts} /. Options[PsychometricFunction];
parameters =
Switch[distribution
,WeibullDistribution,Sequence@@{slope,sfunction@threshold}
,NormalDistribution,Sequence@@{sfunction@threshold,1/slope}
,LogisticDistribution,Sequence@@{sfunction@threshold,1/slope}
,UniformDistribution,sfunction[threshold +{-1,1}/2/slope]];
guess + (1 - guess - lapse) CDF[distribution[parameters],sfunction[strength]]
]



(* ::Input::Initialization:: *)
PsychometricFit::usage = "PsychometricFit[data_]: Fits a set of psychometric data with a psychometric function. The function returns the input data, the function name, and the specified and estimated parameters, and the residual error. The format of the returned material is {data, function, {parameters, error}}. The residual error is -2 times the log of the ratio of constrained and unconstrained hypotheses, which is asymptotically Chi-Square. The fit is based upon a maximum likelihood method, as described in: Watson, A. B. (1979) Probability summation over time, Vision Research 19, 515-522. \!\(\*
StyleBox[\"data\",\nFontSlant->\"Italic\"]\) is a list of triples of the form {strength,no,yes}, where strength is a measure of signal strength, no is the number of no or incorrect responses, and yes is the number of yes or correct reponses. The function also accepts a list of such tables, and produces one fit per table. The function also accepts the data structure produced by QuestExperiment from the notebook Quest.nb. 
Options:
PsychometricFunction: name of the psychometric function to be fit (default = LogWeibullPF). The function must adhere to a standard format: function[x_, parameters_List]. 
PsychometricParameters: initial or final values of psychometric function parameters (default = {Automatic, 4., 0.5, .01}). The value Automatic in the first position indicates that the initial value will be estimated from the data. This estimate is obtained by evaluating the log likelihood function, using the default parameters for the psychometric function, at each intensity used, and selecting the intensity with the largest likelihood. This log likelihood function can be plotted by selecting the option PlotLikelihood->True. 
FitParameters: specifies whether each parameter should be estimated (default = {True}). Unspecified values default to False. For example, to estimate only the first and third parameters, use FitParameters->{True,False,True}. By convention, the first parameter is threshold and the second parameter is slope. This convention is relevant only in functions such as PsychometricPlot, which accepts directly the output of PsychometricFit. 
FitLimits: bounds on each parameter (default = {Automatic, {0,$MaxMachineNumber}, {0,1}, {0,1}}
FitMethod: the function used to optimize parameters (default = FindMinimum). As an alterantive the method NMinimize may be specified, which returns a more global optimum.";


(* ::Input::Initialization:: *)
Options[PsychometricFit] = {PsychometricFunction->LogWeibullPF, PsychometricParameters->{Automatic,4.,0.5,0.01}, FitParameters->{True},
FitLimits->{Automatic,{0,$MaxMachineNumber},{0,1},{0,1}},
PlotLikelihood->False,FitMethod->FindMinimum,Verbose->False};


(* ::Input::Initialization:: *)
PsychometricFit[data_,opts___Rule]:=Block[{fit,function,limits,params,err,args,strength,no,yes,total,result,dummy,dum1,dum2,dum3,dum4,dum5,dum6,plotlike,fmethod,m0,m1,df,logbinomial,terr,terrf,verbose},{fit,params,function,limits,plotlike,fmethod,verbose}={FitParameters,PsychometricParameters,PsychometricFunction,FitLimits,PlotLikelihood,FitMethod,Verbose}/.  {opts}/.  Options[PsychometricFit];
{strength,no,yes}=Transpose[data];total=no+yes;dummy=Take[{dum1,dum2,dum3,dum4,dum5,dum6},Length[params]];

fit=Join[fit,Table[False,{Length[params]-Length[fit]}]];
df = Length[total]-Count[fit,True];
m1:=Total[NLogP[yes,#1]+NLogP[no,(1-#1)]]&[function[strength,dummy]];
logbinomial =N@Total[Log[Binomial[total,yes]]];
m0=N@Total[NLogP[yes,yes/total]+NLogP[no,no/total]];

terr=m1/.  MapThread[#1->#2&,Rest/@{dummy,params}];
terrf=logbinomial+(terr/. {dum1->#1}&)/@strength;
If[plotlike,Print @ListLinePlot[Transpose[{strength,terrf}]
,FrameLabel->{"Strength","Log Likelihood"},Mesh->True,PsychometricaStyles]];
If[params[[1]]===Automatic,params[[1]]=strength[[IndexMax[terrf]]]];
If[limits[[1]]=== Automatic,limits[[1]]=MinMax[strength]];
If[verbose,Print["limits =",limits,"\ndf = ",df,"\nlogbinomial = ",logbinomial]];

result=Switch[fmethod,
FindMinimum,
(args={};
Table[If[fit[[i]]
,args=Append[args,Flatten[{dummy[[i]],params[[i]]+ {0,.001},limits[[i]]}]]
,dummy[[i]]=params[[i]]],{i,Length[params]}];
args=Prepend[args,-m1];
Check[FindMinimum@@args,{Null,(#1->Null&)/@dummy},{FindMinimum::"fmlim",FindMinimum::cvmit}]),
NMinimize,
(vars={};
cons = {};
Table[If[fit[[i]]
,(vars=Append[vars,dummy[[i]]];
cons = Append[cons,limits[[i,1]]<dummy[[i]]<limits[[i,2]]])
,dummy[[i]]=params[[i]]],{i,Length[params]}];
args={Prepend[cons,-m1],vars};

Check[NMinimize@@args,{Null,(#1->Null&)/@dummy}])];
{data,function,{dummy/.  result[[2]],2(m0+result[[1]])}}]


(* ::Input::Initialization:: *)
PsychometricFit[data_,opts___Rule] :=
PsychometricFit[SequenceToTable[First[data]],opts] /;
 Depth[data] == 4 &&
 Not[Equal @@ (Last /@ (Dimensions /@ data))]


(* ::Input::Initialization:: *)
PsychometricFit[data_,opts___Rule] :=
 PsychometricFit[#,opts]& /@ data /;
 Depth[data] == 4 &&
 Equal @@ (Last /@ (Dimensions /@ data))


(* ::Input::Initialization:: *)
PsychometricPlot::usage = "PsychometricPlot[fitdata]: Plots a set of psychometric data and a psychometric function, as returned by PsychometricFit. See that function for details. Also draws approximate Bernoulli confidence intervals around each data point, unless the option PsychErrorBars->False is given. To suppress printing of parameters and error of the fit, use the option PsychLegend->False. Options to ListPlot may also be included.";


(* ::Input::Initialization:: *)
Options[PsychometricPlot] = {PsychErrorBars->True, PsychLegend->True};


(* ::Input::Initialization:: *)
PsychometricPlot[{data_,function_,{params_,error_}},opts___Rule]:=Module[{val,no,yes,vrange,vminmax,xminmax,pdata,pfunc,pbars,plegend,bars,legend,trials},{bars,legend}={PsychErrorBars,PsychLegend}/.  {opts}/.  Options[PsychometricPlot];{val,no,yes}=Transpose[data];vminmax={Min@#,Max@#}&@val;
vrange=-Subtract@@vminmax;
xminmax=vminmax+.1vrange{-1,1};
trials = Total[no+yes];
pbars=Graphics[{GrayLevel[0.75],MapThread[Line[Transpose[{{#1,#1},BinomialErrorBars[#2,#3]}]]&,{val,no,yes}]}];

plegend=Graphics[Text[Style[#,TextAlignment->Left]& @ 
(StringJoin@@Flatten[{ToString[function],Table[{"\n",ArgumentNames[function][[1,i+1]]," = ",ToString@NumberForm[params[[i]],3]},{i,Length[params]}],"\nerror = ",ToString@NumberForm[error,3]
,"\ntrials = ",ToString@trials}]),Scaled[{0,1}],{-1.2,1.1}]];

pdata=ListPlot[Transpose[{val,yes/(yes+no)}]
,Sequence@@FilterRules[Flatten[{opts}],Options[ListPlot]]
,PlotRange->{xminmax,{-.02,1.02}}
,FrameLabel->{"Strength","Probability"}
,Axes->False
,PlotStyle->{PointSize[0.03]}
,PsychometricaStyles];
pfunc=Plot[function[x,params],{x,xminmax[[1]],xminmax[[2]]}
,PlotRange->All
,Evaluate[Sequence@@FilterRules[Flatten[{opts}],Options[Plot]]]
,PlotStyle->AbsoluteThickness[1]
,Evaluate @PsychometricaStyles];
Show[pdata,pfunc,If[legend,plegend,{}],If[bars,pbars,{}],pdata]]


(* ::Input::Initialization:: *)
PsychometricPlot[data_,opts___Rule] :=
 PsychometricPlot[#,opts]& /@ data /;
  Depth[data] == 5


(* ::Input::Initialization:: *)
SequenceToTable::usage = "SequenceToTable[QSequence]: Converts a QSequence data structure as produced by Quest into a table of the form {{{strength, #wrong, #right},...},...} where there is one list of triples for each condition. This is the data structure expected by PsychometricFit.";


(* ::Input::Initialization:: *)
SequenceToTable[seq_] := Block[{a,x,b,c,d,e,y},
 Map[Rest,
(Sort[#/.{{a__,0} ->{a,1,0},{a__,1} ->{a,0,1}}] //. 
{x___,{a__,b_,c_},{a__,d_,e_},y___} -> {x,{a,b+d,c+e},y})& /@
 Table[Cases[seq,{cond,__}]
 ,{cond,Max[First /@ seq]}] ,{2}]]


(* ::Input::Initialization:: *)
BinomialErrorBars::usage = "BinomialErrorBars[failures,sucesses]:  Compute approximate confidence intervals on the probability p of a  binomial random variable, given numbers of failures and successes.";


(* ::Input::Initialization:: *)
rsign[x_] := Floor[x / (x + 1.) + .6]


(* ::Input::Initialization:: *)
tail[no_,yes_] := Exp[Log[.05] / (yes + no)]


(* ::Input::Initialization:: *)
aprox1[no_,yes_] := (yes + .5 + 1.92 + 1.96 Sqrt[(yes + .5)*
 (1. - (yes + .5) /(yes + no)) + .96]) / (yes + no + 3.842)


(* ::Input::Initialization:: *)
aprox2[no_,yes_] := (yes - .5 + 1.92 - 1.96 Sqrt[(yes - .5)*
 (1. - (yes - .5) / (yes + no)) + .96]) / (yes + no + 3.842)


(* ::Input::Initialization:: *)
errbr1[no_,yes_] := rsign[no] * aprox1[no,yes] * rsign[yes] +
 (1. - rsign[no]) + (1. - rsign[yes]) * (1. - tail[no,yes]) 


(* ::Input::Initialization:: *)
errbr2[no_,yes_] := rsign[no] * aprox2[no,yes] * rsign[yes] +
 (1. - rsign[no]) * tail[no,yes]


(* ::Input::Initialization:: *)
BinomialErrorBars[no_,yes_] := {errbr2[no,yes],errbr1[no,yes]}


(* ::Input::Initialization:: *)
BinomialCL[no_,yes_,alpha_,opts___] := FindRoot[
   (Beta[x, 1 + yes, 1 + no]*Gamma[2 + no + yes])/
  (Gamma[1 + no]*Gamma[1 + yes]) == alpha
      ,{x,N[yes/(yes+no)]}
      ,opts][[1,2]]


(* ::Input::Initialization:: *)
NLogP[0,0] := 0


(* ::Input::Initialization:: *)
NLogP[n_,0] := -Sign[n] Infinity


(* ::Input::Initialization:: *)
NLogP[n_,p_] := n Log[p]


(* ::Input::Initialization:: *)
SetAttributes[NLogP,Listable]


(* ::Input::Initialization:: *)
NLogP[0_,Indeterminate] := 0


(* ::Input::Initialization:: *)
NLogP[0,0.] := 0



