(***********************************************************************
This file was generated automatically by the Mathematica front end.
It contains Initialization cells from a Notebook file, which typically
will have the same name as this file except ending in ".nb" instead of
".m".

This file is intended to be loaded into the Mathematica kernel using
the package loading commands Get or Needs.  Doing so is equivalent to
using the Evaluate Initialiation Cells menu command in the front end.

DO NOT EDIT THIS FILE.  This entire file is regenerated automatically 
each time the parent Notebook file is saved in the Mathematica front end.
Any changes you make to this file will be overwritten.
***********************************************************************)













BeginPackage["UnitGaussians`"];

UnitGaussian::usage = "UnitGaussian[x] is a unit Gaussian. It has an area of 1. UnitGaussian[x,s] is a scaled unit Gaussian, with scale=s. It has an area of 1, and a height of 1/Abs[s]. UnitGaussian[x,y,s] is a two-dimensional scaled unit Gaussian. It is the product of two scaled unit Gaussians. It has volume of 1 and height of 1/s^2.";

UnitGaussianF::usage = "UnitGaussianF[x,s] is a scaled unit Gaussian in frequency. It is the Fourier transform of UnitGaussian[]. It has height of 1 and area of 1/Abs[s]. UnitGaussianF[x,y,s] is a two-dimensional scaled unit Gaussian in the frequency domain. It is the Fourier transform of ugs2D. It has height of 1 and volume of 1/s^2.";

DoG::usage = "DoG[x,y,{a,ar,s,sr}] is a two-dimensional difference-of-Gaussians function. The center Gaussian has a scale of s, the surround Gaussian a scale of sr*s; the center Gaussian has a volume of a, the surround Gaussian a volume of a*ar (ar is the ratio surround volume/center volume). DoG[x,{a,ar,s,sr}] is a one-dimensional DoG, equal to the cross section, at y=0, through a 2D DoG. ";

DoGF::usage = "DoGF[x,y,{a,ar,s,sr}] is the Fourier transform of DoG[]. DoGF[x,{a,ar,s,sr}] is the one-dimensional version.";

LogDoG::usage = "LogDoG[x,p] returns the log base 10 of a frequency domain DOG with parameters p. Argument x is log base 10 of frequency.";

OctaveToScale::usage = 
  "OctaveToScale[freq,oct] returns the spatial scale for a Gaussian whose \
transform, shifted to freq (thus creating a Gabor function), has a bandwidth \
of oct octaves. See also ScaleToOctave.";

ScaleToOctave::usage = "ScaleToOctave[freq,scale] returns the octave bandwidth for a Gaussian whose transform, shifted to freq (thus creating a Gabor function), has a  spatial scale of scale. See also OctaveToScale. ";

ug::usage = "ug[x] is a unit Gaussian. It has an area of 1.";

ugs::usage = "ugs[x,s] is a scaled unit Gaussian, with scale=s. It has an area of 1, and a height of 1/Abs[s].";

uGs::usage = "uGs[x,s] is a scaled unit Gaussian in frequency. It is the Fourier transform of ugs[]. It has height of 1 and area of 1/Abs[s].";

ugs2D::usage = "ugs2D[x,y,s] is a two-dimensional scaled unit Gaussian. It is the product of two scaled unit Gaussians. It has volume of 1 and height of 1/s^2.";

uGs2D::usage = "uGs2D[x,y,s] is a two-dimensional scaled unit Gaussian in the frequency domain. It is the Fourier transform of ugs2D. It has height of 1 and volume of 1/s^2.";

dog::usage = "dog[x,y,{a,ar,s,sr}] is a two-dimensional difference-of-Gaussians (DOG) function. The center Gaussian has a scale of s, the surround Gaussian a scale of sr*s; the center Gaussian has a volume of a, the surround Gaussian a volume of a*ar (ar is the ratio surround volume/center volume). dog[x,{a,ar,s,sr}] is a one-dimensional DOG, equal to the cross section, at y=0, through a 2D DOG. ";

doG::usage = "doG[x,y,{a,ar,s,sr}] is the Fourier transform of dog[]. doG[x,{a,ar,s,sr}] is the one-dimensional version.";

logDoG::usage = "logDoG[x,p] returns the log base 10 of a frequency domain DOG with parameters p. Argument x is log base 10 of frequency.";

oct2scale::usage = "oct2scale[freq,oct] returns the spatial scale for a Gaussian whose transform, shifted to freq (thus creating a Gabor function), has a bandwidth of oct octaves. See also scale2oct.";

scale2oct::usage = "scale2oct[freq,scale] returns the octave bandwidth for a Gaussian whose transform, shifted to freq (thus creating a Gabor function), has a  spatial scale of scale. See also oct2scale. ";



Begin["Private`"];

ug[x_] := Exp[- Pi x^2]

UnitGaussian[x_] := Exp[- Pi x^2]

ugs[x_,s_] := Abs[s]^-1 ug[x/s]

UnitGaussian[x_,s_] := Abs[s]^-1 UnitGaussian[x/s]

uGs[x_,s_] := ug[s x]

UnitGaussianF[x_,s_] := UnitGaussian[s x]

ugs2D[x_,y_,s_] := ugs[x,s] ugs[y,s]

UnitGaussian[x_,y_,s_] := UnitGaussian[x,s] UnitGaussian[y,s]

uGs2D[x_,y_,s_] := uGs[x,s] uGs[y,s]

UnitGaussianF[x_,y_,s_] := UnitGaussianF[x,s] UnitGaussianF[y,s]

dog[x_,{a_,ar_,s_,sr_}] := a ( ugs[x,s]/Abs[s] - ar ugs[x,s sr]/Abs[s sr] )

DoG[x_,{a_,ar_,s_,sr_}] := a ( UnitGaussian[x,s]/Abs[s] - ar UnitGaussian[x,s sr]/Abs[s sr] )

doG[x_,{a_,ar_,s_,sr_}] := a ( uGs[x,s] - ar uGs[x,s sr] )

DoGF[x_,{a_,ar_,s_,sr_}] := a ( UnitGaussianF[x,s] - ar UnitGaussianF[x,s sr] )

dog[x_,y_,{a_,ar_,s_,sr_}] := a ( ugs2D[x,y,s] - ar ugs2D[x,y,s sr] )

DoG[x_,y_,{a_,ar_,s_,sr_}] := a ( UnitGaussian[x,y,s] - ar UnitGaussian[x,y,s sr] )

doG[x_,y_,{a_,ar_,s_,sr_}] := a ( uGs2D[x,y,s] - ar uGs2D[x,y,s sr] )

DoGF[x_,y_,{a_,ar_,s_,sr_}] := a ( UnitGaussianF[x,y,s] - ar UnitGaussianF[x,y,s sr] )

logDoG[x_,p_List] := Log[10, doG[10^x,p] ]

LogDoG[x_,p_List] := Log[10, DoG[10^x,p] ]

oct2scale[freq_,oct_] := ((2^oct + 1) /(2^oct - 1)) *  
Sqrt[ Log[2] / Pi ] / freq

OctaveToScale[freq_,oct_] := ((2^oct + 1) /(2^oct - 1)) *  
Sqrt[ Log[2] / Pi ] / freq

scale2oct[freq_,scale_] := Log[(freq*scale + (Log[2]/Pi)^(1/2))/(freq*scale - (Log[2]/Pi)^(1/2))]/
  Log[2]

ScaleToOctave[freq_,scale_] := Log[(freq*scale + (Log[2]/Pi)^(1/2))/(freq*scale - (Log[2]/Pi)^(1/2))]/
  Log[2]

End[];
EndPackage[];









